-- name: [CS] Mario_GameShark
-- description: MGS OWNED, MOD CONFIG AND CREATED BY DARKLORD, MGS CO-OWNED BY ARI, MODEL BY ROUNDYTHECARTOON, RIGGING BY 5UP34, VOICE ACTING BY GEEKY

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/blob/main/API-doc.md

    Use this if you're curious on how anything here works >v<
]]

local E_MODEL_CUSTOM_MODEL = smlua_model_util_get_id("mgs_geo")

local TEX_CUSTOM_ICON = get_texture_info("mgs-icon")

local TEXT_MOD_NAME = "Mario_GameShark"

local VOICETABLE_CHAR = {
    [CHAR_SOUND_ATTACKED] = {'MGShurt1.ogg', 'MGShurt2.ogg', 'MGShurt3.ogg', 'MGShurt4.ogg'},
    [CHAR_SOUND_DOH] = 'MGSdoh.ogg',
    [CHAR_SOUND_DROWNING] = {'MGSdrowning1.ogg', 'MGSdrowning2.ogg', 'MGSdrowning3.ogg'},
    [CHAR_SOUND_DYING] = {'MGSdying1.ogg', 'MGSdying2.ogg', 'MGSdying3.ogg', 'MGSdying4.ogg'},
    [CHAR_SOUND_GROUND_POUND_WAH] = {'MGSgroundpoundwah1.ogg', 'MGSgroundpoundwah2.ogg', 'MGSgroundpoundwah3.ogg'},
    [CHAR_SOUND_HAHA] = {'MGShaha1.ogg', 'MGShaha2.ogg', 'MGShaha3.ogg'},
    [CHAR_SOUND_HAHA_2] = {'MGShaha1.ogg', 'MGShaha2.ogg', 'MGShaha3.ogg'},
    [CHAR_SOUND_HERE_WE_GO] = {'MGSherewego1.ogg', 'MGSherewego2.ogg', 'MGSherewego3.ogg'},
    [CHAR_SOUND_HOOHOO] = {'MGShoohoo1.ogg', 'MGShoohoo2.ogg', 'MGShoohoo3.ogg'},
    [CHAR_SOUND_MAMA_MIA] = {'MGSmamamia1.ogg', 'MGSmamamia2.ogg', 'MGSmamamia3.ogg'},
    [CHAR_SOUND_OKEY_DOKEY] = {'MGSokeydokey1.ogg', 'MGSokeydokey2.ogg', 'MGSokeydokey3.ogg'},
    [CHAR_SOUND_ON_FIRE] = 'MGSonfire.ogg',
    [CHAR_SOUND_OOOF] = {'MGSoof1.ogg', 'MGSoof2.ogg', 'MGSoof3.ogg', 'MGSoof4.ogg', 'MGSoof5.ogg', 'MGSoof6.ogg'},
    [CHAR_SOUND_OOOF2] = {'MGSoof1.ogg', 'MGSoof2.ogg', 'MGSoof3.ogg', 'MGSoof4.ogg', 'MGSoof5.ogg', 'MGSoof6.ogg'},
    [CHAR_SOUND_PUNCH_HOO] = {'MGSpunchhoo1.ogg', 'MGSpunchhoo2.ogg'},
    [CHAR_SOUND_PUNCH_WAH] = {'MGSpunchwah1.ogg', 'MGSpunchwah2.ogg'},
    [CHAR_SOUND_PUNCH_YAH] = {'MGSpunchyah1.ogg', 'MGSpunchyah2.ogg'},
    [CHAR_SOUND_SO_LONGA_BOWSER] = {'MGSsolongabowser1.ogg', 'MGSsolongabowser2.ogg'},
    [CHAR_SOUND_TWIRL_BOUNCE] = 'MGStwirlbounce.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'MGSwaaaooow.ogg',
    [CHAR_SOUND_WAH2] = {'MGSpunchwah1.ogg', 'MGSpunchwah2.ogg'},
    [CHAR_SOUND_WHOA] = 'MGSwoah.ogg',
    [CHAR_SOUND_YAHOO] = {'MGSyahoo1.ogg', 'MGSyahoo2.ogg', 'MGSyahoo3.ogg'},
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'MGSwaha.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = {'MGSyahwahhoo1.ogg', 'MGSyahwahhoo2.ogg', 'MGSyahwahhoo3.ogg', 'MGSyahwahhoo4.ogg', 'MGSyahwahhoo5.ogg'},
    [CHAR_SOUND_YAWNING] = 'MGSyawning.ogg',
}


local CAPTABLE_CHAR = {
    normal = smlua_model_util_get_id("mgs_cap_geo"),
    wing = smlua_model_util_get_id("mgs_wing_cap_geo"),
    metal = smlua_model_util_get_id("mgs_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("mgs_metalwing_cap_geo"),
}

if _G.charSelectExists then
    CT_CHAR = _G.charSelect.character_add("Mario_GameShark", {"WHAT IS THIS PLACE?", "A NEW ENVIRONMENT FOR ME TO EXPLORE?", "PERHAPS ONE FOR ME TO...", "CONTROL?", "WHATEVER THE CASE...", "THIS PLACE FEELS WONDERFUL.", "SO MUCH MORE ROOM TO MOVE AND JUMP.", "I FEEL SO FREE.", ". . .", "THANK YOU FOR BRINGING ME HERE, PLAYER.", "YOU WILL NOT REGRET YOUR DECISION."}, "DarkLord, Ari, RoundyTheCartoon, 5UP34, Geeky", {r = 82, g = 8, b = 50}, E_MODEL_CUSTOM_MODEL, CT_MARIO, TEX_CUSTOM_ICON)
    _G.charSelect.character_add_caps(E_MODEL_CUSTOM_MODEL, CAPTABLE_CHAR)

    -- the following must be hooked for each character added
    _G.charSelect.character_add_voice(E_MODEL_CUSTOM_MODEL, VOICETABLE_CHAR)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAR then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAR then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end